
def mcurv( P1,P2,al,mo='-'):
	L = []
	vdif = P2-P1
	vort = vector( (-vdif[1], vdif[0]) )
	C = (P1+P2)/2+al*vort
	for t in srange(0,1,1/100):
		res = P1*(1-t)^2+2*t*(1-t)*C+P2*t^2
		L.append( res  )
	P = list_plot( L, plotjoined=True, thickness=4, linestyle=mo )
	return P

# Cube

P = line([(0,0),(1,0),(1,1),(0,1),(0,0)], thickness= 4)
P += line([(1,0),(3/2,1/2),(3/2,3/2),(1/2,3/2),(0,1)], thickness= 4)
P += line([(1,1),(3/2,3/2)], thickness= 4)
P += point([(0,0),(1,0),(1,1),(0,1),(3/2,1/2),(3/2,3/2),(1/2,3/2)], size=210)
P.set_aspect_ratio(1)
P.axes(False)
P.save('borri0.png')



# Fase 1

P1 = vector((-1,-1))
P2 = vector((1,-1))
P3 = vector((1,1))
P4 = vector((-1,1))
Q1 = vector((-2,-2))
Q2 = vector((2,-2))
Q3 = vector((2,2))
Q4 = vector((-2,2))


P = point([P1,P2,P3,P4], size=210)
P += mcurv(P1,P2,-0.1)
P += mcurv(P2,P3,-0.1)
P += mcurv(P3,P4,-0.1)
P += mcurv(P4,P1,-0.1)

Q = point([Q1,Q2,Q3,Q4], size=210)
Q += mcurv(Q1,Q2,-0.1)
Q += mcurv(Q2,Q3,-0.1)
Q += mcurv(Q3,Q4,-0.1)
Q += mcurv(Q4,Q1,-0.1)

R = mcurv(Q1,P1,-0.1)
R += mcurv(Q2,P2,0.1)
R += mcurv(Q3,P3,-0.1)
R += mcurv(Q4,P4,0.1)


P = P+Q+R
P.set_aspect_ratio(1)
P.axes(False)
P.save('borri1.png')


# Fase 2

P = point([P1,P2,P3,P4], size=210)
P += mcurv(P1,P2,-0.1)
P += mcurv(P2,P3,-0.1)
P += mcurv(P3,P4,-0.1,'--')
P += mcurv(P4,P1,-0.1)

Q = point([Q1,Q2,Q3,Q4], size=210)
Q += mcurv(Q1,Q2,-0.1,'--')
Q += mcurv(Q2,Q3,-0.1,'--')
Q += mcurv(Q3,Q4,-0.1,'--')
Q += mcurv(Q4,Q1,-0.1,'--')

R = mcurv(Q1,P1,-0.1)
R += mcurv(Q2,P2,0.1)
R += mcurv(Q3,P3,-0.1)
R += mcurv(Q4,P4,0.1)


P = P+Q+R
P.set_aspect_ratio(1)
P.axes(False)
P.save('borri2.png')


# Fase 3

P = point([P1,P2,P3,P4], size=0)
P += circle(P1,0.08,fill=True,facecolor='white')
P += circle(P2,0.08,fill=True,facecolor='white')
P += circle(P3,0.08,fill=True,facecolor='white')
P += circle(P4,0.08,fill=True,facecolor='white')
P += mcurv(P1,P2,-0.1,'--')
P += mcurv(P2,P3,-0.1,'--')
P += mcurv(P4,P1,-0.1,'--')

Q = point([Q1], size=210)
P += circle(Q3,0.08,fill=True,facecolor='white')
P += circle(Q2,0.08,fill=True,facecolor='white')
P += circle(Q4,0.08,fill=True,facecolor='white')

R = mcurv(Q1,P1,-0.1,'--')
R += mcurv(Q2,P2,0.1,'--')
R += mcurv(Q3,P3,-0.1,'--')
R += mcurv(Q4,P4,0.1,'--')


P = P+Q+R
P.set_aspect_ratio(1)
P.axes(False)
P.save('borri3.png')



